#include "lis3lv02dq.h"



/*******************************************************************************************************************/
void LIS3L_Enable ()
{
	i2c_start();
	i2c_write(LIS3L + I2C_WRITE);
	i2c_write(LIS3L_CTRL_REG1);
	i2c_write(0xC7);
	i2c_stop();
}

/*******************************************************************************************************************/
uint8_t	LIS3L_WhoAmI ()
{
	// Locals
	uint8_t	whoami = 0x00;

	i2c_start();
	i2c_write(LIS3L + I2C_WRITE);
	i2c_write(LIS3L_WHO_AM_I);
	i2c_start();
	i2c_write(LIS3L + I2C_READ);
	whoami = i2c_readNak();
	i2c_stop();

	return whoami;
}

/*******************************************************************************************************************/
int16_t LIS3L_GetX ()
{
	int16_t	value = 0x00;
	
	i2c_start ();								// send start condition
	i2c_write (LIS3L + I2C_WRITE);				// send LIS3L adress, writing
	i2c_write (LIS3L_OUTX_L | LIS3L_AUTOINC);	// send sub adress with auto increment
	i2c_start ();								// send rep start condition
	i2c_write(LIS3L + I2C_READ);				// send LIS3L address, reading
	value += i2c_readAck();						// read low byte from slave
	value += (i2c_readNak() << 8);				// read high byte from slave
	i2c_stop ();								// send stop condition
	return value;
}

/*******************************************************************************************************************/
int16_t LIS3L_GetY ()
{
	int16_t	value = 0x00;
	
	i2c_start ();								// send start condition
	i2c_write (LIS3L + I2C_WRITE);				// send LIS3L adress, writing
	i2c_write (LIS3L_OUTY_L | LIS3L_AUTOINC);	// send sub adress with auto increment
	i2c_start ();								// send rep start condition
	i2c_write(LIS3L + I2C_READ);				// send LIS3L address, reading
	value += i2c_readAck();						// read low byte from slave
	value += (i2c_readNak() << 8);				// read high byte from slave
	i2c_stop ();								// send stop condition
	return value;
}

/*******************************************************************************************************************/
int16_t LIS3L_GetZ ()
{
	int16_t	value = 0x00;
	
	i2c_start ();								// send start condition
	i2c_write (LIS3L + I2C_WRITE);				// send LIS3L adress, writing
	i2c_write (LIS3L_OUTZ_L | LIS3L_AUTOINC);	// send sub adress with auto increment
	i2c_start ();								// send rep start condition
	i2c_write(LIS3L + I2C_READ);				// send LIS3L address, reading
	value += i2c_readAck();						// read low byte from slave
	value += (i2c_readNak() << 8);				// read high byte from slave
	i2c_stop ();								// send stop condition
	return value;
}

/*******************************************************************************************************************/
void LIS3L_GetXYZ (int16_t * xvalue, int16_t  * yvalue, int16_t * zvalue)
{
	i2c_start ();								// send start condition
	i2c_write (LIS3L + I2C_WRITE);				// send LIS3L adress, writing
	i2c_write (LIS3L_OUTX_L | LIS3L_AUTOINC);	// send sub adress with auto increment
	i2c_start ();								// send rep start condition
	i2c_write(LIS3L + I2C_READ);				// send LIS3L address, reading
	*xvalue =   i2c_readAck();					// read low byte from slave
	*xvalue += (i2c_readAck() << 8);			// read high byte from slave
	*yvalue =   i2c_readAck();					// read low byte from slave
	*yvalue += (i2c_readAck() << 8);			// read high byte from slave
	*zvalue =   i2c_readAck();					// read low byte from slave
	*zvalue += (i2c_readNak() << 8);			// read high byte from slave
	i2c_stop ();								// send stop condition
}



































